import string
import pygame
import OpenGL.GL as gl
import renderer


def init_gl(debugMode=False):
    pygame.display.init()
    pygame.display.set_caption('the invisible hand of adam smith presents ...')
    flags = pygame.OPENGL | pygame.DOUBLEBUF
    if debugMode:
        flags = flags | pygame.RESIZABLE
    return pygame.display.set_mode((800, 600), flags)

def gl_supported(debugMode=False):
    screen = init_gl(debugMode=debugMode)
    gl_version = float(string.split(gl.glGetString(gl.GL_VERSION).strip())[0])
    if gl_version >= 2.0:
        return screen
    else:
        pygame.display.quit()
        return False


class Renderer(renderer.Renderer):
    def __init__(self, glContext=None, *args, **kwds):
        self.gl_context = glContext
        super(Renderer, self).__init__(*args, **kwds)
    
    def init_display(self, windowTitle=None):
        if self.gl_context is None:
            self.gl_context = init_gl(debugMode=self.debug_mode)
        
    
    def get_drawing_surface(self, size=None):
        if size is None:
            raise TypeError('size not defined')
        return pygame.Surface(size, 0)
